
	include "72423.h"

	xdef	_main
	xdef	_ti92plus	
	xdef	_nostub
;*****************************************************
_ti92plus:
_nostub:

LCD_MEM equ     $4C00

DEREF   macro   ; Dn,An
        lsl.w   #2,\1
;        move.l  doorsos::Heap,\2
        move.l  $7592,\2
        move.l  0(\2,\1.w),\2
        endm

ROM_CALL macro
        move.l ($C8),a4
        add.l #\1*4,a4
        move.l (a4),a4
        jsr (a4)
        endm

_main:
		movem.l 	d0-d7/a0-a6,-(a7)
        move.l          $74,OldAutoInt5
	
	move.l          #TSR_End-TSR_Start,d0

        move.l  	d0,-(a7)
        ROM_CALL 	$92    			;jsr     tios::HeapAllocHigh
        addq.l  	#4,a7

        move.w  	d0,Handle
;        move.w  	d0,-(a7)
;        ROM_CALL 	$9A    			;jsr     _ROM_CALL_09A ; lock
;        addq.l  	#2,a7

        move.w  	Handle,d1
        DEREF   	d1,a0

	move.l		a0,a1
	lea		TSR_Start(pc),a2
	move.l          #TSR_End-TSR_Start,d0
	subq.w		#1,d0
LoopCopyTsr:
	move.b		(a2)+,(a1)+
	dbf		d0,LoopCopyTsr

	move.l		a0,$40074
	movem.l 	(a7)+,d0-d7/a0-a6
        rts


NewAutoInt5:
        movem.l         d0-d7/a0-a6,-(a7)

	lea.l		Counter(PC),a0
	add.b		#1,(a0)
	cmp.b		#15,(a0)
	ble		End
	move.b		#0,(a0)

        ROM_CALL 	$18E			:doorsos::FontGetSys
;	clr.w		d7
	lea.l		Font(PC),a0
	move.w		d0,(a0)

        move.w          #0,-(a7)
        ROM_CALL 	$18F			;doorsos::FontSetSys
        lea             2(a7),a7


        ReadClock       Year1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Year10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Month1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Month10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Day1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Day10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Sec1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Sec10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Min1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Min10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Hour1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Hour10
        and.w           #$F,d0
        move.w          d0,-(a7)
        pea             FormatString(pc)
        pea             Buffer(pc)
        ROM_CALL 	$53			;doorsos::sprintf
        lea             12*2+8(a7),a7


        move.w          #4,-(a7)
        pea             Buffer(pc)
        move.w          #19,-(a7)        	; y
        move.w          #177,-(a7)       	; x 177
        ROM_CALL 	$1A9			;doorsos::DrawStrXY
        lea             10(a7),a7

	move.l		 #$FFFFFFFF,LCD_MEM+18*30-4
	move.l		 #$FFFFFFFF,LCD_MEM+18*30-8

	move.l		 #$FFFFFFFF,LCD_MEM+26*30-4
	move.l		 #$FFFFFFFF,LCD_MEM+26*30-8

	bset.b		 #7,LCD_MEM+18*30-8
	bset.b		 #7,LCD_MEM+19*30-8
	bset.b		 #7,LCD_MEM+20*30-8
	bset.b		 #7,LCD_MEM+21*30-8
	bset.b		 #7,LCD_MEM+22*30-8
	bset.b		 #7,LCD_MEM+23*30-8
	bset.b		 #7,LCD_MEM+24*30-8
	bset.b		 #7,LCD_MEM+25*30-8

	lea.l		Font(PC),a0
        move.w          (a0),-(a7)
        ROM_CALL	$18F			;doorsos::FontSetSys
        addq.w          #2,a7
End:
        movem.l         (a7)+,d0-d7/a0-a6
        move.l          OldAutoInt5(pc),-(a7)
        rts


OldAutoInt5     dc.l    0

Handle		dc.w	0
Font		dc.w	0

Counter		dc.b	0

FormatString    dc.b    "%01d%01d:%01d%01d.%01d%01d %01d%01d/%01d%01d/%01d%01d",0
Buffer          dc.b    "                  ",0
        EVEN

TSR_End:

;*****************************************************

	end
