        include "doorsos.h"
;        include "tios.h"
	include "72423.h"

	xdef	_main
	xdef	_comment
        xdef    _ti92plus                                        


;*****************************************************

_main:
;        move.w          #0,$C00000  ; unites secondes
;        move.w          #2,$C00002  ; dizaines secondes
;        move.w          #7,$C00004  ; unites minutes
;        move.w          #0,$C00006  ; dizaines minutes
;        move.w          #7,$C00008  ; unites heures
;        move.w          #1,$C0000A  ; dizaines heures

;        move.w          #0,$C0001A              ; REGD
;        move.w          #0,$C0001C              ; REGE
;        move.w          #%0100,$C0001E          ; REGF
;        move.b          #0,$C00001
;        move.b          #2,$C00003
;        move.b          #0,$C00005
;        move.b          #5,$C00007
;        move.b          #6,$C00009
;        move.b          #1,$C0000B



        clr.w           doorsos::kb_globals+$1C

        move.w          #0,-(a7)
        jsr             doorsos::FontSetSys
        addq.w          #2,a7

MainLoop:
        tst.w           doorsos::kb_globals+$1C
        beq             NoKey
        move.w          doorsos::kb_globals+$1E,d2
        clr.w           doorsos::kb_globals+$1C

        cmp.w           #$108,d2
        beq             exit


NoKey:

       ReadClock       Year1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Year10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Month1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Month10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Day1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Day10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Sec1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Sec10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Min1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Min10
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Hour1
        and.w           #$F,d0
        move.w          d0,-(a7)
        ReadClock       Hour10
        and.w           #$F,d0
        move.w          d0,-(a7)
        pea             FormatString(pc)
        pea             Buffer(pc)
        ROM_CALL 	$53			;doorsos::sprintf
        lea             12*2+8(a7),a7


        move.w          #4,-(a7)
        pea             Buffer(pc)
        move.w          #19,-(a7)        	; y
        move.w          #177,-(a7)       	; x 177
        ROM_CALL 	$1A9			;doorsos::DrawStrXY
        lea             10(a7),a7

	move.l		 #$FFFFFFFF,LCD_MEM+18*30-4
	move.l		 #$FFFFFFFF,LCD_MEM+18*30-8

	move.l		 #$FFFFFFFF,LCD_MEM+26*30-4
	move.l		 #$FFFFFFFF,LCD_MEM+26*30-8

	bset.b		 #7,LCD_MEM+18*30-8
	bset.b		 #7,LCD_MEM+19*30-8
	bset.b		 #7,LCD_MEM+20*30-8
	bset.b		 #7,LCD_MEM+21*30-8
	bset.b		 #7,LCD_MEM+22*30-8
	bset.b		 #7,LCD_MEM+23*30-8
	bset.b		 #7,LCD_MEM+24*30-8
	bset.b		 #7,LCD_MEM+25*30-8

        bra             MainLoop

exit:
	rts



;*****************************************************
; miscellaneous program data
;*****************************************************

FormatString    dc.b    "%01d%01d:%01d%01d.%01d%01d %01d%01d/%01d%01d/%01d%01d",0
Buffer          dc.b    "                                ",0

_comment        dc.b    "72243 test program",0

;*****************************************************

	end
